package jwtmdl

import (
	"fmt"
	"net/http"
	"testing"

	"github.com/gin-gonic/gin"
	"github.com/stretchr/testify/assert"
)

func server() {
	g := gin.Default()
	g.GET("/status", func(c *gin.Context) {
		fmt.Println("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ ")

		c.JSON(200, "Hello")
	})
	g.Run("localhost:8081")
}
func TestDecodeTokenSuccess(t *testing.T) {
	// go server()
	// fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>calling rq ")
	// resp, err := http.NewRequest("GET", "http://localhost:8081/status", nil)
	// fmt.Println("resp  ", resp)
	// fmt.Println("err  ", err)

	//time.Sleep(30 * time.Second)

	// got, _ := DecodeToken("Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJJZCI6InNhbmRlZXBzcyIsImdyb3VwcyI6ImFkbWluIn0.qmA-brbKScqBEFr3wJIuBmcBsERYoNPLnOAHBe4HNh8", "3212mysupersecretpassword")
	// assert.Equal(t, "sandeepss", got["Id"], "it is equal")

}

func TestDecodeTokenvalid(t *testing.T) {
	req, _ := http.NewRequest("POST", "/r/c/mql", nil)
	req.Header.Set("Authorization", "Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJJZCI6InNhbmRlZXBzcyIsImdyb3VwIjpbImFkbWluIl19.dGSKQZMGSEBjgPrjTHJwylcxIxxMKylahuFn7DHR4pc")
	_, derror := DecodeTokenWithJWTKey(req, "mysupersecretpassword")
	assert.NoError(t, derror, "No error occured")

}

// func TestDecodeTokenInvalid(t *testing.T) {
// 	req, _ := http.NewRequest("POST", "/r/c/mql", nil)
// 	req.Header.Set("Authorization", "Bearer yJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJJZCI6InNhbmRlZXBzcyIsImdyb3VwcyI6ImFkbWluIn0.qmA-brbKScqBEFr3wJIuBmcBsERYoNPLnOAHBe4HNh8")
// 	_, derror := DecodeToken(req, "mysupersecretpassword")
// 	assert.Error(t, derror, "error occured")

// }
// func TestDecodeTokenEmpty(t *testing.T) {
// 	req, _ := http.NewRequest("POST", "/r/c/mql", nil)
// 	req.Header.Set("Authorization", "")
// 	_, derror := DecodeToken(req, "mysupersecretpassword")
// 	assert.Error(t, derror, "error occured")

// }

// func TestDecodeTokenWrongAlo(t *testing.T) {
// 	errormdl.IsTestingNegetiveCaseOnCheckBool = true
// 	req, _ := http.NewRequest("POST", "/r/c/mql", nil)
// 	req.Header.Set("Authorization", "Bearer yJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJJZCI6InNhbmRlZXBzcyIsImdyb3VwcyI6ImFkbWluIn0.qmA-brbKScqBEFr3wJIuBmcBsERYoNPLnOAHBe4HNh8")
// 	_, derror := DecodeToken(req, "mysupersecretpassword")
// 	assert.Error(t, derror, "error occured")
// 	errormdl.IsTestingNegetiveCaseOnCheckBool = false
// }
// func TestDecodeTokenWrongTypeConversion(t *testing.T) {
// 	errormdl.IsTestingNegetiveCaseOnCheckBool1 = true
// 	req, _ := http.NewRequest("POST", "/r/c/mql", nil)
// 	req.Header.Set("Authorization", "Bearer yJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJJZCI6InNhbmRlZXBzcyIsImdyb3VwcyI6ImFkbWluIn0.qmA-brbKScqBEFr3wJIuBmcBsERYoNPLnOAHBe4HNh8")
// 	_, derror := DecodeToken(req, "mysupersecretpassword")
// 	assert.Error(t, derror, "error occured")
// 	errormdl.IsTestingNegetiveCaseOnCheckBool1 = false
// }
